%define DATE 20010822
Summary: A Windows 16/32 bit emulator.
Name: wine
Version: %{DATE}
Release: 1
Group: Applications/Emulators
License: Freely distributable
URL: http://www.winehq.com/
Source: ftp://metalab.unc.edu/pub/Linux/ALPHA/wine/development/wine-%{version}.tar.bz2
Source2: wine.userreg
Source3: wine.systemreg
Source4: wine.reg
Patch: wine-redhat.patch
Patch2: wine-timefix.patch
Patch3: wine-20010404-kde2.patch
Buildroot: %{_tmppath}/%{name}-root
ExclusiveArch: %{ix86}
Prefix: /usr
Prereq: shadow-utils
Conflicts: kdebase < 2.0
BuildRequires: docbook-utils

%description
While Wine is usually thought of as a Windows(TM) emulator, the Wine
developers would prefer that users thought of Wine as a Windows
compatibility layer for UNIX. This package includes a program loader,
which allows unmodified Windows 3.1/95/NT binaries to run under Intel
Unixes. Wine does not require MS Windows, but it can use native system
.dll files if they are available.

%package devel
Summary: Wine development environment.
Group: System Environment/Libraries
Requires: wine = %{version}

%description devel
Header and include files for developing applications with the Wine
Windows(TM) emulation libraries.

%prep
%setup -q -n wine
find . -type d -name CVS |xargs rm -rf
%patch -p1 -b .redhat
%patch2 -p1 -b .time
%patch3 -p1 -b .kde2

%build
export CFLAGS="$RPM_OPT_FLAGS"
autoconf
%configure \
	--enable-dll \
	--with-x \
	--prefix=%{prefix} \
	--libdir=%{_libdir}/wine \
	--includedir=%{prefix}/include/wine \
	--sysconfdir=/etc \
	--enable-opengl

make depend
make
make -C documentation wine-doc/index.html

%install
rm -rf $RPM_BUILD_ROOT

%makeinstall libdir=$RPM_BUILD_ROOT/usr/lib/wine includedir=$RPM_BUILD_ROOT/usr/include/wine

# Take care of wine and windows configuration files...
mkdir -p $RPM_BUILD_ROOT/etc
install -c -m 0644 %{SOURCE2} $RPM_BUILD_ROOT/etc/wine.userreg
install -c -m 0644 %{SOURCE3} $RPM_BUILD_ROOT/etc/wine.systemreg
install -c %{SOURCE4} $RPM_BUILD_ROOT/etc/wine.reg

for i in system Desktop Favorites Fonts NetHood "Start Menu/Programs/Startup" \
         Recent SendTo ShellNew system32 Profiles/Administrator; do
	mkdir -p "$RPM_BUILD_ROOT/usr/share/wine-c/windows/$i"
done
mkdir -p "$RPM_BUILD_ROOT/usr/share/wine-c/Program Files/Common Files"
mkdir -p "$RPM_BUILD_ROOT/usr/share/wine-c/My Documents"

for i in shell.dll shell32.dll winsock.dll wnsock32.dll; do
	touch $RPM_BUILD_ROOT/usr/share/wine-c/windows/system/$i
done
touch $RPM_BUILD_ROOT/usr/share/wine-c/autoexec.bat
touch $RPM_BUILD_ROOT/usr/share/wine-c/config.sys
touch $RPM_BUILD_ROOT/usr/share/wine-c/windows/win.ini

cat >$RPM_BUILD_ROOT/usr/share/wine-c/windows/system.ini <<EOF
[mci]
cdaudio=mcicda.drv
sequencer=mciseq.drv
waveaudio=mciwave.drv
avivideo=mciavi.drv
videodisc=mcipionr.drv
vcr=mciviscd.drv
MPEGVideo=mciqtz.drv
EOF

cat >$RPM_BUILD_DIR/wine/RedHat <<EOF
Wine directory structure used in Red Hat Linux:
===============================================

/usr/share/wine-c is the root directory (aka C: drive) wine looks for
by default. It contains (empty) C:\windows and C:\windows\system
directories, needed to operate Wine without an existing Windows installation.

If you want to use Wine with an existing Windows installation that is mounted,
for example, in /mnt/windows-c, edit /etc/wine.conf to say

[Drive C]
Path=/mnt/windows-c
Type=hd
Label=Whatever
Filesystem=win95

instead of the defaults set by installation.

If you do this, you can safely remove /usr/share/wine-c.
(Alternatively, just mount your Windows partition to /usr/share/wine-c.)
EOF

# Allow users to launch Windows programs by just clicking on the .exe file...
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
cat >$RPM_BUILD_ROOT/etc/rc.d/init.d/wine <<EOF
#!/bin/sh
#
# wine		Allow users to run Windows(tm) applications by just clicking
#		on them (or typing ./file.exe)
#
# chkconfig: 2345 99 10
# description: Allow users to run Windows(tm) applications by just clicking \\
# on them (or typing ./file.exe)
#
# (c) 2000 Red Hat, Inc.
#
case "\$1" in
  start)
    /sbin/modprobe binfmt_misc &>/dev/null
    echo ':windows:M::MZ::/usr/bin/wine:' >/proc/sys/fs/binfmt_misc/register
    echo ':windowsPE:M::PE::/usr/bin/wine:' >/proc/sys/fs/binfmt_misc/register
    ;;
  stop)
    echo "-1" >/proc/sys/fs/binfmt_misc/windows
    echo "-1" >/proc/sys/fs/binfmt_misc/windowsPE
    ;;
  *)
    echo "Usage: \$0 {start|stop}"
esac
EOF
chmod 0755 $RPM_BUILD_ROOT/etc/rc.d/init.d/wine

%clean
rm -r $RPM_BUILD_ROOT

%pre
/usr/sbin/groupadd -r wine &>/dev/null || :

%post
if ! grep -q "^/usr/lib/wine$" /etc/ld.so.conf; then
	echo "/usr/lib/wine" >>/etc/ld.so.conf
fi
/sbin/ldconfig
/sbin/chkconfig --add wine
/sbin/chkconfig --level 2345 wine on
/sbin/service wine start &>/dev/null || :

%preun
/sbin/chkconfig --del wine

%postun
perl -pi -e "s,^/usr/lib/wine$,,g" /etc/ld.so.conf
/sbin/ldconfig
/usr/sbin/groupdel wine &>/dev/null || :

%files
%defattr(-,root,root)
%attr(0775, root, wine) %dir /usr/share/wine-c
%attr(0775, root, wine) %dir /usr/share/wine-c/windows
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/system
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/Profiles
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/Profiles/Administrator
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/Desktop
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/Favorites
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/Fonts
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/NetHood
%attr(0775, root, wine) %dir "/usr/share/wine-c/windows/Start Menu"
%attr(0775, root, wine) %dir "/usr/share/wine-c/windows/Start Menu/Programs"
%attr(0775, root, wine) %dir "/usr/share/wine-c/windows/Start Menu/Programs/Startup"
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/Recent
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/SendTo
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/ShellNew
%attr(0775, root, wine) %dir /usr/share/wine-c/windows/system32
%attr(0775, root, wine) %dir "/usr/share/wine-c/Program Files"
%attr(0775, root, wine) %dir "/usr/share/wine-c/Program Files/Common Files"
%attr(0775, root, wine) %dir "/usr/share/wine-c/My Documents"
/usr/lib/wine/lib*.so*
/usr/bin/*
%{_mandir}/man?/*
/usr/share/wine-c/windows/system/*dll
%config /usr/share/wine-c/autoexec.bat
%config /usr/share/wine-c/config.sys
%attr(0664, root, wine) %config /usr/share/wine-c/windows/win.ini
%attr(0664, root, wine) %config /usr/share/wine-c/windows/system.ini
%config /etc/wine.reg
%config /etc/rc.d/init.d/*
%config(missingok) /etc/wine.userreg
%config(missingok) /etc/wine.systemreg
%doc ANNOUNCE BUGS ChangeLog DEVELOPERS-HINTS LICENSE README
%doc AUTHORS WARRANTY RedHat
%doc documentation/ChangeLog.OLD documentation/HOWTO-winelib
%doc documentation/gui documentation/psdrv.reg documentation/shell32
%doc documentation/wine-doc documentation/samples documentation/status

%files devel
%defattr(-,root,root)
/usr/include/*

%changelog
* Wed Aug 22 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010822-1
- Make sure the package can be cleanly uninstalled (#52007)
- Add build dependencies

* Thu Jul 26 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010726-1
- Fix -devel package group (#49989)
- remove internal CVS files
- chkconfig deletion should be in %preun, not %postun
- rename initscript ("Starting windows:" at startup does look off)

* Thu May 03 2001 Bernhard Rosenkraenzer <bero@redhat.com> 20010503-1
- Update
- generate HTML documentation rather than shipping plain docbook text
  (#38453)

* Sat Apr 14 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Update registry to mount "/" as drive "Z:", fixes winedbg (needs to be
  accessible from 'doze drives)
- Don't create KDE 1.x style desktop entries in wineshelllink
- Be more tolerant on failing stuff in %%post

* Thu Mar  1 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update

* Thu Feb 15 2001 Tim Powers <timp@redhat.com>
- fixed time.h build problems

* Wed Jan 31 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add a patch to handle .exe and .com file permissions the way we want them

* Thu Jan 18 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Restore wine's ability to use a global config file, it was removed
  in CVS for whatever reason
- Move libraries to /usr/lib/wine to prevent conflicts with libuser
  (Bug #24202)
- Move include files to /usr/include/wine to prevent it from messing with
  some autoconf scripts (some broken scripts assume they're running on windoze
  if /usr/include/windows.h exists...)

* Tue Dec 19 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Fix %%pre and %%postun scripts
- --enable-opengl, glibc 2.2 should be safe
- Update CVS

* Mon Nov 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update CVS
- Add a new (user) group wine that can write to the "C: drive"
  /usr/share/wine-c
- Fix up winedbg installation (registry entries)
- Add "Program Files/Common Files" subdirectory to the "C: drive", it's
  referenced in the registry

* Wed Oct 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update

* Mon Aug 7 2000 Tim Powers <timp@redhat.com>
- rebuilt with new DGA

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- fix compilation with gcc 2.96

* Fri Jul 21 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Move init script back
- new version
- move man pages to FHS locations

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- move initscript
- new snapshot

* Fri Jun 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Start the initscript on startup

* Mon May  9 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- New version
- new feature: You can now launch wine by just running a windows .exe file
  (./some.exe or just click on it in kfm, gmc and the likes)
- some spec file modifications

* Sun Feb 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- newer version
- Improve the system.ini file - all multimedia stuff should work now.

* Wed Feb  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- enable and fix up the urlmon/wininet patch
- add: autoexec.bat, config.sys, windows/win.ini windows/system.ini
  windows/Profiles/Administrator
- allow i[456]86 arches
- add some system.ini configuration

* Wed Feb  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update current
- add urlmon and wininet patches from Corel (don't apply them for now though)
- create empty shell*dll and winsock*dll files (as mentioned in the HOWTO)

* Mon Jan 17 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update to current (lots of important fixes)
- Fix up the default wine.conf file (We really don't want it to look
  for CD-ROMs in /cdrom!)
- create a "root filesystem" with everything required to run wine without
  windows in /usr/share/wine-c (drive c:)
- add RedHat file in /usr/doc/wine-%{version} explaining the new directory
  layout
- wine-devel requires wine

* Tue Dec 14 1999 Preston Brown <pbrown@redhat.com>
- updated source for Powertools 6.2
- better files list

* Fri Jul 23 1999 Tim Powers <timp@redhat.com>
- updated source
- built for 6.1

* Tue Apr 13 1999 Michael Maher <mike@redhat.com>
- built package for 6.0
- updated package and spec file

* Mon Oct 26 1998 Preston Brown <pbrown@redhat.com>
- updated to 10/25/98 version.  There is really no point in keeping the
- older one, it is full of bugs and the newer one has fewer.
- commented out building of texinfo manual, it is horrendously broken.

* Mon Oct 12 1998 Michael Maher <mike@redhat.com>
- built package for 5.2
- pressured by QA, not updating.

* Fri May 22 1998 Cristian Gafton <gafton@redhat.com>
- repackaged for PowerTools

